#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#include "lutil.h"
#include "nodelist.h"
#include "config.h"

int chat(node*,modem_string*,modem_string*,modem_string*,int,char*);
extern char *predial;

int dialphone(node *nlent,char *phone)
{
        int rc;
        modem_string ms;

        ms.next = NULL;
        ms.expr = NULL;
        ms.line = predial;

        debug(0,"dialling %s",S(phone));
        if ((rc=chat(nlent,modemreset,modemok,modemerror,timeoutreset,phone)))
        {
                logerr("could not reset the modem");
                return 2;
        }
        if (predial != NULL)
        {
           if ((rc=chat(nlent,&ms,modemok,modemerror,timeoutreset,phone)))
           {
                   logerr("predial string (%s)failed",predial);
                   return 2;
           }
        }
        if ((rc=chat(nlent,modemdial,modemconnect,modemerror,
                                timeoutconnect,phone)))
        {
               loginf("could not connect to the remote");
               return 1;
        }
        return 0;
}

int hangup(node *nlent)
{
int err,c,tmp;

     if(hanguptries > 3)
     {
       tmp = verbose;
       verbose = -1;
     }
     debug(0,"hanging up");
     c = 0;
     while(1)
     {
        err = chat(nlent,modemhangup,modemok,modemerror,2*timeoutreset,NULL);
        if (err <= 0)   /* 0 = got ok, -1 = EOF detected, no carrier */
        {
            err = 0;
            break;      /* +ve = got timeout or other error */
        }
        if (c++ > hanguptries)
            break;
     }
     if (hanguptries > 3)
       verbose = tmp;

     return err;
}
